#define INITGUID 1

#include "..\source\dversion.h"//PL for the version number
#include "scrn.h"

#ifndef TARGET_OS_MAC
	#include <windows.h>
#else
	#ifndef TARGET_API_MAC_CARBON
		#define TARGET_API_MAC_CARBON 1
	#endif
	#include <Carbon.h>
	#include <ConditionalMacros.h>
#endif


#include <string.h>
#include <stdlib.h>
#include "xclassver.h"
#include "moatry.h"
#include <locale.h>

//------------------

#define UNUSED(x) 			x

#define PROPBUF_SIZE 		256

#define	SX_CAPTURE_STAGE	1			// sources for screen captures
#define	SX_CAPTURE_SCREEN	2

#define	SX_NORMAL_IMAGE		1			// tells whether to stretch the image or not
#define	SX_RESIZE_IMAGE		2

#define	SX_WRITE_MEMBER		1			// destinations for screen captures
#define	SX_WRITE_CLIPBOARD	2
#define	SX_WRITE_FILE		3


PIMoaMmUtils2				pUtil;

//extern "C" { //-- PL
	HANDLE CopyHandle(HANDLE h);
	int	GrabRect(HDC passedSrcDC, long rleft, long rtop, long rright, long rbottom,
				long newWidth, long newHeight,
				HBITMAP *ptrHBitmap, HANDLE *ptrHDIB, HPALETTE *ptrHPal, HDC stageDC);
	int WriteDIB(const LPSTR szFile, HANDLE hdib);
//}

void dbgs(char* s)
{
	char buf[256];
	strcpy(buf,s);
	strcat(buf, "\n");
	//pUtil->PrintMessage(buf);
	MessageBoxA (NULL, s, "INFO", 0);
}
void dbgi(int n)
{
	char buf[256];
	sprintf(buf, "%d", n);
	//pUtil->PrintMessage(buf);
	MessageBoxA (NULL, buf, "INFO", 0);
}
/*******************************************************************************
 * SCRIPTING XTRA MESSAGE TABLE DESCRIPTION.
 *
 * The general format is:
 * xtra <nameOfXtra>
 * new object me [ args ... ]
 * <otherHandlerDefintions>
 * --
 * The first line must give the name of the Scripting xtra.
 * The remaining lines give the names of the handlers that this xtra implements
 * along with the required types of the arguments for each handler.
 * 
 * -- Pre-defined handler new 
 * The new handler will be called when a child object is created, 
 * the first argument is always the child object and you defined any remaining arguments.
 * The new handler is the place to initialize any memory required by the child object.
 * -- Simple Handler Definitions
 * Each handler definition line is format like this:
 * <handlerName> <argType1> <argName1>, <argType2> <argName2> ...
 * The first word is the handler name. Following this are types description for
 * the argument to the handler, each separated by a comma.
 * The argument name <argName>, may be omited.
 * Permited argument types are: 
 * 	integer 
 * 	float
 * 	string
 * 	symbol
 * 	object
 * 	any
 * 	*
 * For integer, float, string, symbol, and object, the type of the argument must 
 * match. The type any means allow any type. The asterisk (*) means any number and 
 * any type of arguments.
 * 
 * The first argument is the child object and is always declared to be of type object.
 * 
 * -- Global Handlers
 * An asterisk (*) preceeding the handler name signifies a global handler.
 * This handler is at the global scope level and can be called from any
 * movie.
 * 
 * -- Xtra level handlers
 * A plus (+) preceeding the handler name signifies an Xtra level handler. 
 * This kind of handler can be called directly from the Xtra reference,
 * without creating a child object.
 * 
 * The enumerated list that follows must correspond directly with the msgTable 
 * (i.e. they must be in the same order).
 * 
 *******************************************************************************/ 
 
 /* This is the list of handlers for the xtra. The versionInfo string is combined
 /*	with the msgTable string in the register method to create a single string that
 /* used when registering the xtra as a scripting xtra. */

//static char versionInfo[] = "";
static char versionInfo[] = "xtra ScrnXtra -- version %s.%s.%s\n";
const static char msgTable[] = { 
	"xtra ScrnXtra\n"
	"-- ScrnXtra v2.2.0\n"
	"-- Copyright (c) 1996,97,98 Little Planet Publishing.  All rights reserved.\n"
	"-- For updates see http://www.littleplanet.com/kent/kent.html\n"
	"-- Contact the author at kent@littleplanet.com\n"
	"-- This no-charge Xtra may be freely distributed as long as it is\n"
	"-- accompanied by its documentation and sample movie.\n"
	"-- Apdatated for Director 11 by Pierre Luscher"
 	"--\n"

	"-- Stage Capture Functions --\n"
	"* StageToMember int left, int top, int right, int bottom, any memberNumOrName, * -- any castNumOrName = 1, bool trimWhiteSpace = true\n"
	"* StageResizeToMember int left, int top, int right, int bottom, int newWidth, int newHeight, any memberNumOrName, * -- any castNumOrName = 1, bool trimWhiteSpace = true\n"
	"* StageToClipboard int left, int top, int right, int bottom\n"
	"* StageResizeToClipboard int left, int top, int right, int bottom, int newWidth, int newHeight\n"
	"* StageToFile int left, int top, int right, int bottom, string filename\n"
	"* StageResizeToFile int left, int top, int right, int bottom, int newWidth, int newHeight, string filename\n"
 	"--\n"

	"-- Screen Capture Functions --\n"
	"* ScreenToMember int left, int top, int right, int bottom, any memberNumOrName, * -- any castNumOrName = 1, bool trimWhiteSpace = true\n"
	"* ScreenResizeToMember int left, int top, int right, int bottom, int newWidth, int newHeight, any memberNumOrName, * -- any castNumOrName = 1, bool trimWhiteSpace = true\n"
	"* ScreenToClipboard int left, int top, int right, int bottom\n"
	"* ScreenResizeToClipboard int left, int top, int right, int bottom, int newWidth, int newHeight\n"
	"* ScreenToFile int left, int top, int right, int bottom, string filename\n"
	"* ScreenResizeToFile int left, int top, int right, int bottom, int newWidth, int newHeight, string filename\n"
};

/* 	This is the enumerated scripting method list. This list should
 *	directly correspond to the msgTable defined above. It is used
 *	to dispatch method calls via the methodSelector. The 'm_XXXX' method must
 *	be last.
 */

enum 
{
	m_new = 0, /* standard first entry */

m_StageToMember,
m_StageResizeToMember,
m_StageToClipboard,
m_StageResizeToClipboard,
m_StageToFile,
m_StageResizeToFile,
m_ScreenToMember,
m_ScreenResizeToMember,
m_ScreenToClipboard,
m_ScreenResizeToClipboard,
m_ScreenToFile,
m_ScreenResizeToFile,

	m_XXXX
};



/* ============================================================================= */
/* Xtra Glue Stuff */
/* ============================================================================= */

#define XTRA_VERSION_NUMBER XTRA_CLASS_VERSION

BEGIN_XTRA
	BEGIN_XTRA_DEFINES_CLASS(MyXtra, XTRA_CLASS_VERSION)
		CLASS_DEFINES_INTERFACE(MyXtra, IMoaRegister, XTRA_VERSION_NUMBER)
		CLASS_DEFINES_INTERFACE(MyXtra, IMoaMmXScript, XTRA_VERSION_NUMBER)
		/*
		 * ---> insert additional interface(s) -->
		 */ 
	END_XTRA_DEFINES_CLASS
END_XTRA


/* ============================================================================= */
/* Create/Destroy for class MyXtra */
/* ============================================================================= */


STDMETHODIMP MoaCreate_MyXtra (MyXtra FAR * This)
{

	MoaError err = kMoaErr_NoErr;

	//This->pCallback->QueryInterface(&IID_IMoaHandle, (PPMoaVoid)&This->pHandle);
	//This->pCallback->QueryInterface(&IID_IMoaAppInfo, (PPMoaVoid)&This->pAppInfo);

	This->pCallback->QueryInterface(&IID_IMoaMmValue, (PPMoaVoid) &This->pValueInterface);
	//This->pCallback->QueryInterface(&IID_IMoaMmList, (PPMoaVoid) &This->pListInterface);
	This->pCallback->QueryInterface(&IID_IMoaMmUtils2, (PPMoaVoid) &This->pMoaUtils);
	pUtil = This->pMoaUtils;
	This->pCallback->QueryInterface(&IID_IMoaDrUtils, (PPMoaVoid) &This->pDrUtils);
	This->pCallback->QueryInterface(&IID_IMoaMmImage, (PPMoaVoid) &This->pImageInterface);
	//ThrowErr (This->pCallback->QueryInterface(&IID_IMoaMmWndWin, (PPMoaVoid) &This->pWindowInterface));

	//This->pCallback->QueryInterface(&IID_IMoaDrMovie, (PPMoaVoid) &This->pMovieInterface);
	This->pCallback->QueryInterface(&IID_IMoaDrPlayer, (PPMoaVoid)&This->pDrPlayer);
	This->pCallback->MoaCreateInstance(&CLSID_CMoaFile2, &IID_IMoaFile2,(PPMoaVoid)&This->pMoaFile);

	This->pMovieInterface = NULL;

	return err;
}

STDMETHODIMP_(void) MoaDestroy_MyXtra(MyXtra FAR * This)
{

	if (This->pValueInterface) This->pValueInterface->Release();
	This->pValueInterface = NULL;

	if (This->pMoaUtils) This->pMoaUtils->Release();
	This->pMoaUtils = NULL;

	//if (This->pMovieInterface != NULL) This->pMovieInterface->Release();

	if (This->pDrUtils) This->pDrUtils->Release();
	This->pDrUtils = NULL;

	if (This->pImageInterface) This->pImageInterface->Release();
	This->pImageInterface = NULL;

	if (This->pDrPlayer) This->pDrPlayer->Release();
	This->pDrPlayer = NULL;

	if (This->pMoaFile) This->pMoaFile->Release();
	This->pMoaFile = NULL;

}


/* ============================================================================= */
/* Methods in MyXtra_IMoaRegister */
/* ============================================================================= */

/*****************************************************************************
 *  Data needed for Registering
 *	---------------------------
 *	Specific code needed to register different types of Xtras.  The skeleton
 *	source files include minimal implementations appropriate for each Xtra
 *	type.  Current necessary actions:
 *
 *	Scripting Xtra:				Add the Scripting Xtra Message Table
 *	Sprite Asset Xtra:			Nothing
 *	Tool Xtra:					Nothing
 *	Transition Asset Xtra		Nothing
 *
 *  ****optional: Register as Safe for Shockwave!
 *****************************************************************************/ 

STD_INTERFACE_CREATE_DESTROY(MyXtra, IMoaRegister)

BEGIN_DEFINE_CLASS_INTERFACE(MyXtra, IMoaRegister)
END_DEFINE_CLASS_INTERFACE

/* ----------------------------------------------------------------------------- */
STDMETHODIMP MyXtra_IMoaRegister::Register(
	PIMoaCache pCache, 
	PIMoaXtraEntryDict pXtraDict
)
{	

	MoaError 		err = kMoaErr_NoErr;


moa_try
	PIMoaRegistryEntryDict		pReg;
	MoaBool						bItsSafe = TRUE;
	char versionStr[256];
	PMoaVoid pMemStr = NULL;

	// Register the lingo xtra
	ThrowErr(pCache->AddRegistryEntry(pXtraDict, &CLSID_MyXtra, &IID_IMoaMmXScript, &pReg));

	// Register the method table
	sprintf(versionStr, versionInfo, VER_MAJORVERSION_STRING, VER_MINORVERSION_STRING, VER_BUGFIXVERSION_STRING);

	//pMemStr = pObj->pCalloc->NRAlloc(sizeof(msgTable1));
	pMemStr = pObj->pCalloc->NRAlloc(sizeof(msgTable) + sizeof(versionStr));

	ThrowNull(pMemStr);

	strcpy((char *)pMemStr, versionStr);
	strcat((char *)pMemStr, msgTable);

	//pMemStr = (char *)malloc(500);
	//strcpy((char *)pMemStr, msgTable1);

	ThrowErr(pReg->Put(kMoaDrDictType_MessageTable, pMemStr, 0, kMoaDrDictKey_MessageTable));

	// Mark xtra as safe for shockwave - but only if it IS safe !
	// ThrowErr(pReg->Put(kMoaMmDictType_SafeForShockwave, &bItsSafe, sizeof(bItsSafe), kMoaMmDictKey_SafeForShockwave));

moa_catch
moa_catch_end
	if (pMemStr)
		pObj->pCalloc->NRFree(pMemStr);
moa_try_end


	return err;
}



/* ============================================================================= */
/*  Methods in MyXtra_IMoaMmXScript */
/* ============================================================================= */

BEGIN_DEFINE_CLASS_INTERFACE(MyXtra, IMoaMmXScript)
END_DEFINE_CLASS_INTERFACE

//******************************************************************************
MyXtra_IMoaMmXScript::MyXtra_IMoaMmXScript(MoaError FAR * pError)
//------------------------------------------------------------------------------
{
	*pError = kMoaErr_NoErr;
}	

//******************************************************************************
MyXtra_IMoaMmXScript::~MyXtra_IMoaMmXScript()
//------------------------------------------------------------------------------
{
}


/* ----------------------------------------------------------------------------- */
STDMETHODIMP MyXtra_IMoaMmXScript::Call (PMoaDrCallInfo callPtr)
{
	MoaError		err 		= kMoaErr_NoErr;

	// Get the active movie
	if ((err = pObj->pDrPlayer->GetActiveMovie(&pObj->pMovieInterface)) != kMoaErr_NoErr) 
		goto exit_gracefully;

	switch	( callPtr->methodSelector ) 
	{
		case m_StageToMember:
			err = XPly_CaptureMethod(callPtr,
							SX_CAPTURE_STAGE, SX_WRITE_MEMBER, SX_NORMAL_IMAGE);
			break;

		case m_StageResizeToMember:
			err = XPly_CaptureMethod(callPtr,
							SX_CAPTURE_STAGE, SX_WRITE_MEMBER, SX_RESIZE_IMAGE);
			break;
		case m_StageToClipboard:
			err = XPly_CaptureMethod(callPtr,
							SX_CAPTURE_STAGE, SX_WRITE_CLIPBOARD, SX_NORMAL_IMAGE);
			break;

		case m_StageResizeToClipboard:
			err = XPly_CaptureMethod(callPtr,
							SX_CAPTURE_STAGE, SX_WRITE_CLIPBOARD, SX_RESIZE_IMAGE);
			break;
		
		case m_StageToFile:
			err = XPly_CaptureMethod(callPtr,
							SX_CAPTURE_STAGE, SX_WRITE_FILE, SX_NORMAL_IMAGE);
			break;
		
		case m_StageResizeToFile:
			err = XPly_CaptureMethod(callPtr,
							SX_CAPTURE_STAGE, SX_WRITE_FILE, SX_RESIZE_IMAGE);
			break;
		
		case m_ScreenToMember:
			err = XPly_CaptureMethod(callPtr,
							SX_CAPTURE_SCREEN, SX_WRITE_MEMBER, SX_NORMAL_IMAGE);
			break;
		
		case m_ScreenResizeToMember:
			err = XPly_CaptureMethod(callPtr,
							SX_CAPTURE_SCREEN, SX_WRITE_MEMBER, SX_RESIZE_IMAGE);
			break;

		case m_ScreenToClipboard:
			err = XPly_CaptureMethod(callPtr,
							SX_CAPTURE_SCREEN, SX_WRITE_CLIPBOARD, SX_NORMAL_IMAGE);
			break;

		case m_ScreenResizeToClipboard:
			err = XPly_CaptureMethod(callPtr,
							SX_CAPTURE_SCREEN, SX_WRITE_CLIPBOARD, SX_RESIZE_IMAGE);
			break;
		
		case m_ScreenToFile:
			err = XPly_CaptureMethod(callPtr,
							SX_CAPTURE_SCREEN, SX_WRITE_FILE, SX_NORMAL_IMAGE);
			break;
		
		case m_ScreenResizeToFile:
			err = XPly_CaptureMethod(callPtr,
							SX_CAPTURE_SCREEN, SX_WRITE_FILE, SX_RESIZE_IMAGE);
			break;
	}
exit_gracefully:
	return(err);
}


/*****************************************************************************
 *  Private Methods
 *  -------------------
 *  Implementation of Private Class Methods
 /*
 *  This is the actual code for the defined methods. They are defined as 
 *  functions, and called from the switch statement in Call().
 *
 ****************************************************************************/


//-------------------- registerXtra

// Lower-level routines return 0 for success or a negative error code for failure.

MoaError MyXtra_IMoaMmXScript::XPly_CaptureMethod(PMoaDrCallInfo callPtr,
										long captureSource,
										long captureDest,
										long imageSize)
{
	MoaMmValue	arg1, arg2, arg3, arg4, arg5, arg6, arg7, argMember, argCast;
	int retVal, argCastGiven;
	long rleft, rtop, rright, rbottom, newWidth, newHeight;
	char memberName[256], castName[256]; 
	MoaChar	filename[PROPBUF_SIZE];
	PIMoaDrCast pCast;
	MoaMmSymbol formatSymbol, labelSymbol, typeSymbol;
	MoaMmValueType argType;
	MoaDrMediaInfo mediaInfo;
	MoaDrCastIndex castIndex;
	MoaDrMemberIndex memberIndex;   
	PIMoaDrCastMem pCastMem;
	PIMoaMmGC pGC;
	MoaError err = kMoaErr_NoErr;
	MoaMmNativeGCInfo nativeGC;
	#ifdef MACINTOSH
	CGrafPtr stagePort;
	PicHandle picHdl;
	#else
	HDC stageDC;
	HBITMAP hBitmap;
	HANDLE hDIB;
	HPALETTE hPal;
	#endif
	//-- PL
	MoaMmValue argTrimWhiteSpace;
	MoaLong bTrimWhiteSpace;
	MoaLong lOptions;
	//--/PL

	//UNUSED(This);
	//globalThis = This;

	GetArgByIndex(1, &arg1);
	GetArgByIndex(2, &arg2);
	GetArgByIndex(3, &arg3);
	GetArgByIndex(4, &arg4);
	pObj->pValueInterface->ValueToInteger(&arg1, &rleft);	// convert arguments to longs
	pObj->pValueInterface->ValueToInteger(&arg2, &rtop);
	pObj->pValueInterface->ValueToInteger(&arg3, &rright);
	pObj->pValueInterface->ValueToInteger(&arg4, &rbottom);

	argCastGiven = 0;						// 1 if cast # or name passed, 0 if not

	if(imageSize == SX_NORMAL_IMAGE) {
		newWidth = rright - rleft;			// same size; no change
		newHeight = rbottom - rtop;
	}
	else {
		GetArgByIndex(5, &arg5);			// fetch new width, height arguments
		GetArgByIndex(6, &arg6);
		pObj->pValueInterface->ValueToInteger(&arg5, &newWidth);
		pObj->pValueInterface->ValueToInteger(&arg6, &newHeight);
	}

	switch(captureSource) {
		case SX_CAPTURE_STAGE:
			// grab the Graphics Context info	

			//MOVIE(GetStageWindowGC)(MOVARG_ &pGC);
			pObj->pMovieInterface->GetStageWindowGC(&pGC);

			//pGC->lpVtbl->GetNativeGCInfo(pGC, &nativeGC);
			pGC->GetNativeGCInfo(&nativeGC);

			#ifdef MACINTOSH
			if(nativeGC.type == kMoaMmGCType_MacWindow)
				stagePort = (CGrafPtr) nativeGC.data.mac_window.windowPtr;
			else if(nativeGC.type == kMoaMmGCType_MacGWorld)
				stagePort = (CGrafPtr) nativeGC.data.mac_gworld.gworldPtr;
			else {
				retVal = -105;
				break;
			}
			retVal = GrabRect(stagePort, rleft, rtop, rright, rbottom,
							newWidth, newHeight, &picHdl);
			#else
			stageDC = (HDC) nativeGC.data.win_window.hDC;
			retVal = GrabRect(stageDC, rleft, rtop, rright, rbottom, 
							newWidth, newHeight, &hBitmap, &hDIB, &hPal, stageDC);

			#endif
			pGC->Release();//???
			break;

		case SX_CAPTURE_SCREEN:
			// grab the Graphics Context info	
			#ifdef MACINTOSH
			retVal = GrabRect(0, rleft, rtop, rright, rbottom, newWidth, newHeight, &picHdl);
			#else

			//MOVIE(GetStageWindowGC)(MOVARG_ &pGC);
			pObj->pMovieInterface->GetStageWindowGC(&pGC);

			//pGC->lpVtbl->GetNativeGCInfo(pGC, &nativeGC);
			pGC->GetNativeGCInfo(&nativeGC);

			stageDC = (HDC) nativeGC.data.win_window.hDC;
			retVal = GrabRect(0, rleft, rtop, rright, rbottom, 
							newWidth, newHeight, &hBitmap, &hDIB, &hPal, stageDC);
			pGC->Release();//???

			#endif
			break;
	}

	if(retVal != 0) {								// problems during the capture, bail out
		pObj->pValueInterface->IntegerToValue(retVal, &callPtr->resultValue);
		return(0);
	}

	switch(captureDest) {
		case SX_WRITE_CLIPBOARD:
			#ifdef MACINTOSH
			if(ZeroScrap() != noErr) {
				retVal = -102;
				break;
			}
			HLock((Handle) picHdl);
			if(PutScrap(GetHandleSize((Handle) picHdl), (ResType) 'PICT', (Ptr) *picHdl) != noErr)
				retVal = -103;
			HUnlock((Handle) picHdl);
			#else
			if(OpenClipboard(GetDesktopWindow())) {
				retVal = 0;
				if(EmptyClipboard()) {
					if(SetClipboardData(CF_DIB, CopyHandle((HANDLE) hDIB)) == NULL)
						retVal = -206;
				}
				else
					retVal = -205;
				if(!CloseClipboard())
					retVal = -207;
			}
			else
				retVal = -204;
			#endif
			break;

		case SX_WRITE_FILE:
			if(imageSize == SX_NORMAL_IMAGE) {
				GetArgByIndex(5, &arg5);
				pObj->pValueInterface->ValueToString(&arg5, filename, PROPBUF_SIZE);
			}
			else {
				GetArgByIndex(7, &arg7);
				pObj->pValueInterface->ValueToString(&arg7, filename, PROPBUF_SIZE);
			}
			
			
			#ifdef MACINTOSH
				retVal = WritePICT(filename, picHdl);
			#else
				retVal = WriteDIB((PMoaChar) filename, hDIB);
			#endif

			break;

		case SX_WRITE_MEMBER:
			bTrimWhiteSpace = true; //PL default value, like previous version behavior

			if(imageSize == SX_NORMAL_IMAGE) {
				GetArgByIndex(5, &argMember);
				if(callPtr->nargs > 5) {	// cast name or number is optional
					argCastGiven = 1;
					GetArgByIndex(6, &argCast);
				}
				//-- PL
				if(callPtr->nargs > 6) {
					GetArgByIndex(7, &argTrimWhiteSpace);
					pObj->pValueInterface->ValueToInteger(&argTrimWhiteSpace, &bTrimWhiteSpace);

				}
				//--/PL
			}
			else {
				GetArgByIndex(7, &argMember);
				if(callPtr->nargs > 7) {	// cast name or number is optional
					argCastGiven = 1;
					GetArgByIndex(8, &argCast);
				}
				//-- PL
				if(callPtr->nargs > 8) {
					GetArgByIndex(9, &argTrimWhiteSpace);
					pObj->pValueInterface->ValueToInteger(&argTrimWhiteSpace, &bTrimWhiteSpace);
				}
				//--/PL
			}

			if(argCastGiven) {
				pObj->pValueInterface->ValueType(&argCast, &argType);
				switch(argType) {
					case kMoaMmValueType_Integer:
						pObj->pValueInterface->ValueToInteger(&argCast, &castIndex);
						break;

					case kMoaMmValueType_String:
						pObj->pValueInterface->ValueToString(&argCast, castName, 256);

						//err = MOVIE(GetCastIndexFromName)(MOVARG_ castName, &castIndex);
						err = pObj->pMovieInterface->GetCastIndexFromName(castName, &castIndex);

						if(err != kMoaErr_NoErr)
							retVal = -21;
						break;

					default:				// unrecognized type passed in
						retVal = -22;
				}
			}
			else							// no cast specified, assume "Internal"
				castIndex = 1;

			if(retVal != 0)
				break;						// jump out if there was an error

			//err = MOVIE(GetNthCast)(MOVARG_ castIndex, &pCast);
			err = pObj->pMovieInterface->GetNthCast(castIndex, &pCast);


			if(err != kMoaErr_NoErr) {				// invalid cast specified
				retVal = -23;
				break;
			}

			pObj->pValueInterface->ValueType(&argMember, &argType);	// figure out if member ref is an int or string
			switch(argType) {
				case kMoaMmValueType_Integer:
					pObj->pValueInterface->ValueToInteger(&argMember, &memberIndex);
					break;

				case kMoaMmValueType_String:
					pObj->pValueInterface->ValueToString(&argMember, memberName, 256);

					//err = pCast->lpVtbl->GetMemberIndexFromName(pCast, memberName, &memberIndex); 
					err = pCast->GetMemberIndexFromName(memberName, &memberIndex);

					if(err != kMoaErr_NoErr) {
						//pCast->lpVtbl->Release(pCast);
						pCast->Release();//???
						retVal = -31;
						break;
					}
					break;

				default:							// unrecognized type passed in
					//pCast->lpVtbl->Release(pCast);
					pCast->Release();//???
					retVal = -32;
					break;
			}

			if(retVal != 0)
				break;						// jump out if there was an error

			pObj->pValueInterface->StringToSymbol("bitmap", &typeSymbol);
			//if(pCast->lpVtbl->CreateCastMem(pCast, memberIndex, typeSymbol) != kMoaErr_NoErr) {
			if(pCast->CreateCastMem(memberIndex, typeSymbol) != kMoaErr_NoErr) {
				//pCast->lpVtbl->Release(pCast);
				pCast->Release();//???
				retVal = -41;
				break;
			}

			lOptions = kMoaDrImgMediaOpts_ImageDepthAndPal;
			//-- PL
			if (! bTrimWhiteSpace)
				lOptions |= kMoaDrImgMediaFlags_DontTrimWhiteEdges; 
			//--/PL

			pObj->pValueInterface->StringToSymbol("Image", &labelSymbol);
			#ifdef MACINTOSH
			pObj->pValueInterface->StringToSymbol("macPICT", &formatSymbol);
			err = pObj->pMoaUtils->NewMediaInfo(labelSymbol, formatSymbol,
						(PMoaVoid) picHdl, lOptions,
						(PMoaVoid) NULL, &mediaInfo);
			#else
			pObj->pValueInterface->StringToSymbol("winDIB", &formatSymbol);
			err = pObj->pDrUtils->NewMediaInfo(labelSymbol, formatSymbol,
						(PMoaVoid) hDIB, lOptions,
						(PMoaVoid) NULL, &mediaInfo);
			#endif
			if(err != kMoaErr_NoErr) {
				//pCast->lpVtbl->Release(pCast);
				pCast->Release();//???
				retVal = -42;
				break;
			}

			//if(pCast->lpVtbl->GetCastMem(pCast, memberIndex, &pCastMem) != kMoaErr_NoErr) {
			if(pCast->GetCastMem(memberIndex, &pCastMem) != kMoaErr_NoErr) {
				//pCast->lpVtbl->Release(pCast);
				pCast->Release();//???
				retVal = -43;
				break;
			}

		// DOESN'T HELP!!!
		//MoaMmSymbol  symbol;
		//MoaMmValue	 moaValue;
		//pObj->pValueInterface->StringToSymbol("trimWhiteSpace", &symbol);
		//pObj->pValueInterface->IntegerToValue(0, &moaValue);
		//pCastMem->SetProp(symbol, &moaValue);


			#ifdef MACINTOSH
				mediaInfo.mediaData = picHdl;
			#else
				mediaInfo.mediaData = hDIB;
			#endif
			//if(pCastMem->lpVtbl->SetMedia(pCastMem, &mediaInfo) != kMoaErr_NoErr) {
			if(pCastMem->SetMedia(&mediaInfo) != kMoaErr_NoErr) {
				//pCastMem->lpVtbl->Release(pCastMem);
				pCastMem->Release();
				//pCast->lpVtbl->Release(pCast);
				pCast->Release();//???
				retVal = -44;
				break;
			}

			//pCastMem->lpVtbl->Release(pCastMem);
			pCastMem->Release();//???
			//pCast->lpVtbl->Release(pCast);
			pCast->Release();//???
			break;
	}

	#ifdef MACINTOSH
	KillPicture(picHdl);
	#else
	DeleteObject(hBitmap);
//	DeleteObject(hPal);
	GlobalFree(hDIB);
//	GlobalFree(hPal);
	#endif

	pObj->pValueInterface->IntegerToValue(retVal, &callPtr->resultValue);
	return(0);
}


void GetDirRGB(int ndx, int *r, int *g, int *b)
{
	MoaMmRGBTriple RGBColor;
	//CScrnUtilXtra_IMoaDrXLingo FAR *This;

	//This = globalThis;
	pUtil->IndexToRGB((MoaMmColorIndex) ndx, &RGBColor);
	*r = RGBColor.red;
	*g = RGBColor.green;
	*b = RGBColor.blue;
}

