// ScrnMac.c for ScrnXtra
// Kent Kersten, 26-Apr-96
// copyright (c) 1996 by Little Planet Publishing, all rights reserved
// heavily reworked April 1997

#ifdef	__MWERKS__

#include <windows.h>
#include <string.h>

#include	<Types.h>
#include	<Memory.h>
#include	<Quickdraw.h>
#include	<Scrap.h>
#include	<Files.h>
#include	<Finder.h>
#include	<Errors.h>


//#include "beepimp.h" /* MODIFY to match the project's xxxxIMP.H filename trp */
#include "script.h" //-- PL
#include "scrn.h" //-- PL

//-- PL dplac dans Scrn.h
/*** 
void ctopstr(char *);					// put prototypes here so CW doesn't complain
int WritePICT(char *, PicHandle);
int	GrabRect(CGrafPtr, long, long, long, long, long, long, PicHandle *);
***/

// prototype priv
	PixMapHandle createScreenPixMap(Rect * srcRect, Rect * destRect);
//--/PL

// Convert the given C-format (null terminate) string to Pascal format in situ.

void ctopstr(char *thestring)
{
	int i, len;
	char *ptr;

	for(len = 0, ptr = thestring;*ptr;ptr++)
		++len;
	for(i = len;i;i--)
		thestring[i] = thestring[i-1];
	*thestring = (unsigned char) len;
}


// Write out the given picture to a disk file.
// Return 0 for success, a negative error code for failure.

int WritePICT(char *filename, PicHandle picHdl)
{
	short refNum;
	long totalBytes, fivetwelve = 512;
	//char dummyPictHdr[512] = " This picture was written with ScrnXtra v2.0 by Little Planet Publishing ";
	char dummyPictHdr[512] = " This picture was written with ScrnXtra v2.1 by Little Planet Publishing "; //-- PL

	ctopstr(filename);
#if TARGET_API_MAC_CARBON //-- PL
	FSSpec spec;
	FSMakeFSSpec(0,0,(ConstStr255Param) filename, &spec);
	
	FSpCreate(&spec, 'ttxt', 'PICT', smSystemScript);
#else
	Create((ConstStr255Param) filename, 0, 'ttxt', 'PICT');
#endif	

#if TARGET_API_MAC_CARBON //-- PL
	if(FSpOpenDF(&spec, 0, &refNum) != noErr) 
#else	
	if(FSOpen((ConstStr255Param) filename, 0, &refNum) != noErr) 
#endif
	{
		FSClose(refNum);
		return(-10);
	}
	HLock((Handle) picHdl);
	totalBytes = GetHandleSize((Handle) picHdl);
	if(FSWrite(refNum, &fivetwelve, dummyPictHdr) != noErr) {
		HUnlock((Handle) picHdl);
		FSClose(refNum);
		return(-11);
	}
	if(FSWrite(refNum, &totalBytes, *picHdl) != noErr) {
		HUnlock((Handle) picHdl);
		FSClose(refNum);
		return(-11);
	}
	HUnlock((Handle) picHdl); //-- PL
	if(FSClose(refNum) != noErr)
		return(-12);
	return(0);
}


// Return 0 for success, a negative number for failure.

int	GrabRect(CGrafPtr passedGrafPort, long rleft, long rtop, long rright, long rbottom,
			long newWidth, long newHeight, PicHandle *ptrPicHdl)
{
	Rect 	srcRect, destRect;
	long 	destWidth, destHeight;
	
	srcRect.top = (int) rtop;
	srcRect.left = (int) rleft;
	srcRect.bottom = (int) rbottom;
	srcRect.right = (int) rright;

	destRect.top = 0;
	destRect.left = 0;
	if((newHeight > 0) && (newWidth > 0)) 
	{
		destRect.bottom = (int) newHeight;
		destRect.right = (int) newWidth;
	}
	else 
	{
		destRect.bottom = (int) (rbottom - rtop);
		destRect.right = (int) (rright - rleft);
	}
	destWidth = destRect.right;
	destHeight = destRect.bottom;
	
	
#if TARGET_API_MAC_CARBON //-- PL
	// CGrafPort est maintenant opaque
	// GetCWMgrPort, OpenCPort CloseCPort ne sont plus supports
	
	long 			pixelDepth, myRowBytes;
	CGrafPtr 		sourcePort; 
	CGrafPtr        cgOffScrnPtr;
	GrafPtr 		savePort = nil;
	PixMapHandle	pixHandle = nil;
	PicHandle		thePict = nil;
	Ptr 			offScrnBits;
	RgnHandle 		saveClipRgn;
	
	
	if (passedGrafPort)
	{
		//stage copy
		GetPort(&savePort);	
		sourcePort = passedGrafPort;
		
		cgOffScrnPtr = CreateNewPort();
		
		pixelDepth = (*(GetPortPixMap(sourcePort)))->pixelSize;	// only use longs in these calculations!
		// the next line makes sure we get an even byte count for 'rowBytes'
		myRowBytes = (((destWidth * pixelDepth) + 15) / 16) * 2;
		offScrnBits = NewPtr(myRowBytes * destHeight);
		if(offScrnBits == nil)
			return(-104);
		
		/***
		char temp[256];
		//sprintf(temp, "pixelDepth: %i", pixelDepth);
		sprintf(temp, "destWidth: %i, destHeight: %i", destWidth, destHeight);
		MyAlert(temp);
		sprintf(temp, "myRowBytes: %i", myRowBytes);
		MyAlert(temp);
		***/
		
		(*(GetPortPixMap(cgOffScrnPtr)))->baseAddr = offScrnBits;
		(*(GetPortPixMap(cgOffScrnPtr)))->rowBytes = myRowBytes + 0x8000;	// set top bit
		(*(GetPortPixMap(cgOffScrnPtr)))->bounds = destRect;
		
		SetPort((GrafPtr) cgOffScrnPtr);
		ClipRect(&destRect);
		EraseRect(&destRect);

		SetPort((GrafPtr) sourcePort);
		saveClipRgn = NewRgn();
		GetClip(saveClipRgn);						// preserve previous clipping region
		ClipRect(&srcRect);							// make sure the area we are capturing is available

		CopyBits(GetPortBitMapForCopyBits(sourcePort), 
				GetPortBitMapForCopyBits(cgOffScrnPtr), 
				&srcRect, &destRect, srcCopy, nil);
				
		SetPort((GrafPtr) cgOffScrnPtr);
		thePict = OpenPicture(&destRect);
		if (thePict == nil) 
		{
			SetPort((GrafPtr) sourcePort);
			SetClip(saveClipRgn);
			DisposeRgn(saveClipRgn);
			DisposePtr(offScrnBits);
			DisposePort(cgOffScrnPtr);
			SetPort(savePort);
			return(-101);
		}
		
		//HLock((Handle) thePict);
	
		// now copy it to itself to create the picture
		CopyBits(GetPortBitMapForCopyBits(cgOffScrnPtr), 
				GetPortBitMapForCopyBits(cgOffScrnPtr), 
				&destRect, &destRect, srcCopy, nil);
		ClosePicture();
		
		SetPort((GrafPtr) sourcePort);
		SetClip(saveClipRgn);						// restore previous clipping region
		DisposeRgn(saveClipRgn);
		DisposePtr(offScrnBits);
		DisposePort(cgOffScrnPtr);
		SetPort(savePort);
		
		//HUnlock((Handle) thePict);
		*ptrPicHdl = thePict;
	}
	else
	{
		//screen copy
		GetPort(&savePort);	
		
		pixHandle = createScreenPixMap(&srcRect, &destRect);
		LockPixels(pixHandle);
		
		cgOffScrnPtr = CreateNewPort();
		
		pixelDepth = (*pixHandle)->pixelSize;	// only use longs in these calculations!
		// the next line makes sure we get an even byte count for 'rowBytes'
		myRowBytes = (((destWidth * pixelDepth) + 15) / 16) * 2;
		offScrnBits = NewPtr(myRowBytes * destHeight);
		if(offScrnBits  == nil)
			return(-104);
			
		(*(GetPortPixMap(cgOffScrnPtr)))->baseAddr = offScrnBits;
		(*(GetPortPixMap(cgOffScrnPtr)))->rowBytes = myRowBytes + 0x8000;	// set top bit
		(*(GetPortPixMap(cgOffScrnPtr)))->bounds = destRect;
		
		SetPort((GrafPtr) cgOffScrnPtr);
		ClipRect(&destRect);
		EraseRect(&destRect);
		
		thePict = OpenPicture(&destRect);
		if (thePict == nil) 
		{
			DisposePtr(offScrnBits);
			DisposePort(cgOffScrnPtr);
			SetPort(savePort);
			return(-101);
		}
		
		//HLock((Handle) thePict);
	
		CopyBits((BitMap*) *pixHandle, 
				GetPortBitMapForCopyBits(cgOffScrnPtr),
				&destRect, &destRect, srcCopy, 0L);
	 
		ClosePicture();
		DisposePtr(offScrnBits);
		DisposePort(cgOffScrnPtr);
		UnlockPixels(pixHandle);
		SetPort(savePort);
		
		//HUnlock((Handle) thePict);
		*ptrPicHdl = thePict;
	}
	
#else
	// Mac Classic, comme avant
	
	long 		pixelDepth, myRowBytes;
	PicHandle 	thePict;
	Ptr 		offScrnBits;
	GrafPtr 	savePort;
	RgnHandle 	saveClipRgn;
	CGrafPtr 	sourcePort, cgOffScrnPtr;
	CGrafPort 	cgOffScrnPort;
	
	GetPort(&savePort);
	
	if(passedGrafPort)
		sourcePort = passedGrafPort;			// use passed-in graphics port
	else
		GetCWMgrPort(&sourcePort);				// use desktop window port

	cgOffScrnPtr = &cgOffScrnPort;				// create our off-screen grafport
	OpenCPort(cgOffScrnPtr);

	pixelDepth = (*(sourcePort->portPixMap))->pixelSize;	// only use longs in these calculations!
	// the next line makes sure we get an even byte count for 'rowBytes'
	myRowBytes = (((destWidth * pixelDepth) + 15) / 16) * 2;
	if((offScrnBits = NewPtr(myRowBytes * destHeight)) == nil)
		return(-104);
		
	(*(cgOffScrnPtr->portPixMap))->baseAddr = offScrnBits;
	(*(cgOffScrnPtr->portPixMap))->rowBytes = myRowBytes + 0x8000;	// set top bit
	(*(cgOffScrnPtr->portPixMap))->bounds = destRect;
	
	SetPort((GrafPtr) cgOffScrnPtr);
	ClipRect(&destRect);
	EraseRect(&destRect);

	SetPort((GrafPtr) sourcePort);
	saveClipRgn = NewRgn();
	GetClip(saveClipRgn);						// preserve previous clipping region
	ClipRect(&srcRect);							// make sure the area we are capturing is available

	CopyBits((BitMap *) *(sourcePort->portPixMap), (BitMap *) *(cgOffScrnPtr->portPixMap),
				&srcRect, &destRect, srcCopy, nil);	// blap


	SetPort((GrafPtr) cgOffScrnPtr);
	if ((thePict = OpenPicture(&destRect)) == nil) {
		SetPort((GrafPtr) sourcePort);
		SetClip(saveClipRgn);
		DisposeRgn(saveClipRgn);
		DisposePtr(offScrnBits);
		CloseCPort(cgOffScrnPtr);
		SetPort(savePort);
		return(-101);
	}

	HLock((Handle) thePict);
	
	// now copy it to itself to create the picture
	CopyBits((BitMap *) *(cgOffScrnPtr->portPixMap), (BitMap *) *(cgOffScrnPtr->portPixMap),
				&destRect, &destRect, srcCopy, nil);	// blap
	ClosePicture();
	
	SetPort((GrafPtr) sourcePort);
	SetClip(saveClipRgn);						// restore previous clipping region
	DisposeRgn(saveClipRgn);
	DisposePtr(offScrnBits);
	CloseCPort(cgOffScrnPtr);
	SetPort(savePort);

	HUnlock((Handle) thePict);
	*ptrPicHdl = thePict;
	
#endif
	
	return(0);
}

//-- PL comme l'example Apple SuperSnapShot :
PixMapHandle createScreenPixMap(Rect * pSrcRect, Rect * pDestRect)
{
	GDHandle	mainDevice;
	CTabHandle	cTable;
	short		depth;	
	Ptr			offBaseAddr;	/* Pointer to the off-screen pixel image */
	short		bytesPerRow;
	PixMapHandle	pixHandle = nil;
	//Rect		bounds;
	
	pixHandle = NewPixMap();
		
	/* Get a handle to the main device. */
	mainDevice = GetMainDevice();

	/* Store its current pixel depth. */
	depth = (**(**mainDevice).gdPMap).pixelSize;

	/* Make an identical copy of its pixmap's colortable. */
	cTable = (**(**mainDevice).gdPMap).pmTable;
	(void) HandToHand( (Handle*)&cTable );
	
	// Get Resolution of screen
	/***
	BitMap bitMap;
	GetQDGlobalsScreenBits(&bitMap);
	SetRect( &bounds, 0, 0, bitMap.bounds.right, bitMap.bounds.bottom);
	***/
	
	// Fill in a few of the PixMap's fields...
	// NewPixMap() is good for default initialization, simply modify
	// the new PixMap
	(*pixHandle)->pmTable = cTable;
	//(*pixHandle)->bounds = *pSrcRect;
	(*pixHandle)->bounds = *pDestRect;//-- PL v2.1.1
	
	(*pixHandle)->pixelSize = depth;
	bytesPerRow = ((pSrcRect->right - pSrcRect->left) * depth) / 8;
	offBaseAddr = NewPtr((unsigned long) bytesPerRow * (pSrcRect->bottom - pSrcRect->top));
	(*pixHandle)->baseAddr = offBaseAddr;  			// Point to image
	(*pixHandle)->rowBytes = bytesPerRow | 0x8000;	// MSB set for PixMap
	
	LockPixels(pixHandle);
	
	CopyBits( (BitMap *)*(**mainDevice).gdPMap, (BitMap *) *pixHandle,
				pSrcRect, pDestRect, srcCopy, nil );
	
	UnlockPixels(pixHandle);
	
	return pixHandle;
}
//--/PL

#endif		// __MWERKS__
